module cubeset_index
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetools_setup_types
  use cubeset_messaging
  !
  public :: index
  private
  !
  type :: index_comm_t
     type(option_t),      pointer :: comm
     type(keywordlist_comm_t), pointer :: index_arg
   contains
     procedure, public  :: register => cubeset_index_register
     procedure, private :: parse    => cubeset_index_parse
     procedure, private :: print    => cubeset_index_print
  end type index_comm_t
  type(index_comm_t) :: index
  !
contains
  !
  subroutine cubeset_index_command(line,error)
    !---------------------------------------------------------------------
    ! Support routine for command
    ! INDEX INPUT|CURRENT
    !---------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: rname='INDEX>COMMAND'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    if (index%comm%getnarg().eq.0) then
       call index%print(error)
       return
    endif
    call index%parse(line,error)
    if (error) return
  end subroutine cubeset_index_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubeset_index_register(index,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    class(index_comm_t), intent(inout) :: index
    logical,             intent(inout) :: error
    !
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: comm_abstract = &
         'Set which index should be used when searching for cubes'
    character(len=*), parameter :: comm_help = &
         'No argument shows current value. Default is DAG'
    character(len=*), parameter :: rname='INDEX>REGISTER'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'INDEX','[INPUT|CURRENT]',&
         comm_abstract,&
         comm_help,&
         cubeset_index_command,&
         index%comm,error)
    if (error) return
    call keyarg%register( &
         'name',  &
         'Name of the index to be used', &
         strg_id,&
         code_arg_optional, &
         indexname, &
         .not.flexible, &
         index%index_arg, &
         error)
    if (error) return
  end subroutine cubeset_index_register
  !
  subroutine cubeset_index_parse(index,line,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_comm_t), intent(in)    :: index
    character(len=*),    intent(in)    :: line
    logical,             intent(inout) :: error
    !
    integer(kind=4) :: ikey
    character(len=16) :: keyword,argum
    character(len=*), parameter :: rname='INDEX>PARSE'
    !
    call cubeset_message(setseve%trace,rname,'Welcome')
    call cubetools_getarg(line,index%comm,1,argum,mandatory,error)
    if (error) return
    call cubetools_keywordlist_user2prog(index%index_arg,argum,ikey,keyword,error)
    if (error) return
    cubset%index%default = ikey
  end subroutine cubeset_index_parse
  !
  subroutine cubeset_index_print(index,error)
    use cubeadm_setup
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(index_comm_t), intent(in)    :: index
    logical,             intent(inout) :: error
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='INDEX>PRINT'
    !
    call cubeset_message(seve%r,rname,'  Index')
    write(mess,'(a,a)') '    Default: ',indexname(cubset%index%default)
    call cubeset_message(seve%r,rname,mess)
  end subroutine cubeset_index_print
end module cubeset_index

module cubelist_object_types
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  !
  public :: list_object_t
  private
  !
  ! Basic object type
  type, abstract :: list_object_t
     ! Empty
  contains
    procedure(final_interface), deferred, public :: final
  end type list_object_t
  !
  abstract interface
    subroutine final_interface(obj,error)
      import list_object_t
      !-----------------------------------------------------------------
      ! The 'list_object_t' must provide an explicit FINAL method. It
      ! can not be implicit because of the weird finalization of
      ! structure constructor in Fortran 2008/11). See also related bug
      ! in https://gcc.gnu.org/bugzilla/show_bug.cgi?id=112459
      !-----------------------------------------------------------------
      class(list_object_t), intent(inout) :: obj
      logical,              intent(inout) :: error
    end subroutine final_interface
  end interface
  !
end module cubelist_object_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_dataformat_types
  use cubetools_parameters
  use cubesyntax_messaging
  use cubetools_structure
  !
  public :: dataformat_opt_t,datadescr_opt_t
  public :: code_dataformat_none,  &
            code_dataformat_cube,code_dataformat_interface, &
            code_dataformat_fits,code_dataformat_gdf,code_dataformat_vo,&
            code_dataformat_cdf
  private
  !
  integer(kind=code_k), parameter :: code_dataformat_none      = 0
  integer(kind=code_k), parameter :: code_dataformat_cube      = 1
  integer(kind=code_k), parameter :: code_dataformat_interface = 2
  integer(kind=code_k), parameter :: code_dataformat_fits      = 3
  integer(kind=code_k), parameter :: code_dataformat_cdf       = 4
  integer(kind=code_k), parameter :: code_dataformat_gdf       = 5
  integer(kind=code_k), parameter :: code_dataformat_vo        = 6

  integer(kind=4),       parameter :: form_l = 9
  integer(kind=4),       parameter :: ndataformat = 6
  character(len=form_l), parameter :: dataformatkeys(ndataformat) = [&
       'CUBE     ',&
       'INTERFACE',&
       'FITS     ',&
       'CDF      ',&
       'GDF      ',&
       'VO       ']
  !
  type dataformat_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: arg
   contains
     procedure :: register  => cubetools_dataformat_register
     procedure :: parse     => cubetools_dataformat_parse
  end type dataformat_opt_t
  !
  type datadescr_opt_t
     type(option_t),      pointer :: opt
     type(keywordlist_comm_t), pointer :: arg
   contains
     procedure :: register  => cubetools_datadescr_register
     procedure :: parse     => cubetools_datadescr_parse
  end type datadescr_opt_t
  !
contains
  !
  subroutine cubetools_dataformat_register(dataformat,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(dataformat_opt_t), intent(out)   :: dataformat
    logical,                 intent(inout) :: error
    !
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='DATAFORMAT>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'FORMAT','format',&
         'Select the format to list the header',&
         'The are 3 possible formats: CUBE (default if option is not&
         & given), GDF (same as in VECTOR\GREG) and FITS (List the&
         & FITS file header)',&
         dataformat%opt,error)
    if (error) return
    call keyarg%register( &
         'format',  &
         'Listing format for the header', &
         strg_id,&
         code_arg_mandatory, &
         dataformatkeys, &
         .not.flexible, &
         dataformat%arg, &
         error)
    if (error) return
  end subroutine cubetools_dataformat_register
  !
  subroutine cubetools_datadescr_register(datadescr,error)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(datadescr_opt_t), intent(out)   :: datadescr
    logical,                intent(inout) :: error
    !
    type(keywordlist_comm_t) :: keyarg
    character(len=*), parameter :: rname='DATADESCR>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         'DESCRIPTION','Description',&
         'Select the format to describe',&
         strg_id,&
         datadescr%opt,error)
    if (error) return
    call keyarg%register( &
         'description',  &
         'Listing format to be described', &
         strg_id,&
         code_arg_mandatory, &
         dataformatkeys, &
         .not.flexible, &
         datadescr%arg, &
         error)
    if (error) return
  end subroutine cubetools_datadescr_register
  !
  subroutine cubetools_dataformat_parse(dataformat,line,code,error)
    use cubetools_structure
    use cubetools_disambiguate
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    class(dataformat_opt_t), intent(in)    :: dataformat
    character(len=*),        intent(in)    :: line
    integer(kind=code_k),    intent(inout) :: code  ! Unchanged if option missing
    logical,                 intent(inout) :: error
    !
    integer(kind=4) :: ikey
    logical :: do
    character(len=argu_l) :: keyword,argument
    integer(kind=argu_k), parameter :: iarg=1
    character(len=*), parameter :: rname='DATAFORMAT>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call dataformat%opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,dataformat%opt,1,argument,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(dataformat%arg,argument,ikey,keyword,error)
       if (error) return
       code = ikey
    endif
  end subroutine cubetools_dataformat_parse
  !
  subroutine cubetools_datadescr_parse(datadescr,line,code,error)
    use cubetools_structure
    use cubetools_disambiguate
    !---------------------------------------------------------------------
    !  ZZZ Identical to cubetools_dataformat_parse except input class!
    !---------------------------------------------------------------------
    class(datadescr_opt_t), intent(in)    :: datadescr
    character(len=*),       intent(in)    :: line
    integer(kind=code_k),   intent(inout) :: code  ! Unchanged if option missing
    logical,                intent(inout) :: error
    !
    integer(kind=4) :: ikey
    logical :: do
    character(len=argu_l) :: keyword,argument
    integer(kind=argu_k), parameter :: iarg=1
    character(len=*), parameter :: rname='DATADESCR>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call datadescr%opt%present(line,do,error)
    if (error) return
    if (do) then
       call cubetools_getarg(line,datadescr%opt,1,argument,mandatory,error)
       if (error) return
       call cubetools_keywordlist_user2prog(datadescr%arg,argument,ikey,keyword,error)
       if (error) return
       code = ikey
    endif
  end subroutine cubetools_datadescr_parse
end module cubetools_dataformat_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubecompute_sum
  use cubetools_parameters
  use cubecompute_two2one_template
  use cubecompute_messaging
  !
  public :: cubecompute_sum_register
  private
  !
  type(two2one_comm_t) :: sum
  !
contains
  !
  subroutine cubecompute_sum_register(error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUM>REGISTER'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call sum%register_syntax(&
         'SUM','summand1','summand2',&
         code_access_imaset,[flag_sum],cubecompute_sum_command,error)
    if (error) return
    !
    call sum%unit%register(cubecompute_sum_prog_unit,error)
    if (error) return
    !
    call sum%act%register_imaima2ima(cubecompute_sum_prog_act_imaima,error)
    if (error) return
    call sum%act%register_imavis2vis(cubecompute_sum_prog_act_imavis,error)
    if (error) return
    call sum%act%register_visima2vis(cubecompute_sum_prog_act_visima,error)
    if (error) return
    call sum%act%register_visvis2vis(cubecompute_sum_prog_act_visvis,error)
    if (error) return
  end subroutine cubecompute_sum_register
  !
  subroutine cubecompute_sum_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(two2one_user_t) :: user
    character(len=*), parameter :: rname='SUM>COMMAND'
    !
    call cubecompute_message(computeseve%trace,rname,'Welcome')
    !
    call sum%parse(line,user,error)
    if (error) return
    call sum%main(user,error)
    if (error) continue
  end subroutine cubecompute_sum_command
  !
  subroutine cubecompute_sum_prog_unit(unit1,unit2,ouunit,error)
    !----------------------------------------------------------------------
    ! Set the proper unit of the output cube
    !----------------------------------------------------------------------
    character(len=*), intent(inout) :: unit1
    character(len=*), intent(inout) :: unit2
    character(len=*), intent(inout) :: ouunit
    logical,          intent(inout) :: error
    !
    character(len=*), parameter :: data_unit_null='---'  ! To be factorized
    character(len=*), parameter :: rname='SUM>UNIT'
    !
    if (unit1.ne.unit2) then
       call cubecompute_message(seve%w,rname,'Mixing units '//trim(unit1)//' and '//unit2)
    endif
    ouunit = unit1
  end subroutine cubecompute_sum_prog_unit
  !
  !----------------------------------------------------------------------
  !
  subroutine cubecompute_sum_prog_act_imaima(ie,summand1,summand2,sum,error)
    use cubetools_parameters
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: summand1
    type(image_t),        intent(inout) :: summand2
    type(image_t),        intent(inout) :: sum
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUM>PROG>ACT>IMAIMA'
    !
    include 'action-sum.inc'
  end subroutine cubecompute_sum_prog_act_imaima
  !
  subroutine cubecompute_sum_prog_act_imavis(ie,summand1,summand2,sum,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(image_t),        intent(inout) :: summand1
    type(visi_t),         intent(inout) :: summand2
    type(visi_t),         intent(inout) :: sum
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUM>PROG>ACT>IMAVIS'
    !
    include 'action-sum.inc'
  end subroutine cubecompute_sum_prog_act_imavis
  !
  subroutine cubecompute_sum_prog_act_visima(ie,summand1,summand2,sum,error)
    use cubetools_parameters
    use cubeadm_image_types
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(visi_t),         intent(inout) :: summand1
    type(image_t),        intent(inout) :: summand2
    type(visi_t),         intent(inout) :: sum
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUM>PROG>ACT>VISIMA'
    !
    include 'action-sum.inc'
  end subroutine cubecompute_sum_prog_act_visima
  !
  subroutine cubecompute_sum_prog_act_visvis(ie,summand1,summand2,sum,error)
    use cubetools_parameters
    use cubeadm_visi_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    integer(kind=entr_k), intent(in)    :: ie
    type(visi_t),         intent(inout) :: summand1
    type(visi_t),         intent(inout) :: summand2
    type(visi_t),         intent(inout) :: sum
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SUM>PROG>ACT>VISVIS'
    !
    include 'action-sum.inc'
  end subroutine cubecompute_sum_prog_act_visvis
end module cubecompute_sum
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! *** JP For historical reasons, center is still used in some places
! *** JP As a matter of fact, this is a more generic notion of spatial position
! *** JP It could be a center or something else.
! *** JP Where center is still hardtyped, we should have the possibility to customize
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetopology_spapos_types
  use cubetools_parameters
  use cubetools_structure
  use cubetools_keywordlist_types
  use cubetopology_messaging
  !
  public :: spapos_comm_t,spapos_user_t,spapos_prog_t
  private
  !
  character(len=8), parameter :: ctypes(3) = [strg_star//'       ','Relative','Absolute']
  !
  type spapos_comm_t
     type(option_t),           pointer, private :: key
     type(keywordlist_comm_t), pointer, private :: coortype
   contains
     procedure, public :: register => cubetopology_spapos_register
     procedure, public :: parse    => cubetopology_spapos_parse
  end type spapos_comm_t
  !
  type spapos_user_t
      ! ***JP: Most of these ones are misused. They should be private
     logical,               public :: present = .false. ! Present or absent?
     character(len=argu_l), public :: x = strg_star     ! Position along x-axis
     character(len=argu_l), public :: y = strg_star     ! Position along y-axis
     character(len=argu_l), public :: type = strg_star  ! Absolute or relative coordinates?
     character(len=argu_l), public :: unit = strg_star  ! Position unit, context dependent
   contains
     procedure, public  :: init        => cubetopology_spapos_user_init
     procedure, public  :: from_line   => cubetopology_spapos_user_from_line
     procedure, public  :: toprog      => cubetopology_spapos_user_toprog
     procedure, private :: toprog_rela => cubetopology_spapos_user_toprog_rela
     procedure, private :: toprog_abso => cubetopology_spapos_user_toprog_abso
     procedure, public  :: list        => cubetopology_spapos_user_list
  end type spapos_user_t
  !
  !***JP: The spapos_prog_t is too simple or too complex. It should only
  !***JP: have the absolute coordinates in radian, and methods to convert
  !***JP: to relative, frac, pixe, ie, depending on the image to which the
  !***JP: absolute coordinates are applied.
  type spapos_prog_t
     real(kind=coor_k),    public :: abso(2) = (/ 0d0,0d0 /) ! [rad]
     real(kind=coor_k),    public :: rela(2) = (/ 0d0,0d0 /) ! [rad]
     real(kind=coor_k),    public :: frac(2) = (/ 0d0,0d0 /) ! Pixel fractional position
     integer(kind=pixe_k), public :: pixe(2) = (/   0,0   /) ! Nearest integer pixel
     integer(kind=entr_k), public :: ie                      ! Closest Matching entry
   contains
     procedure :: list => cubetopology_spapos_prog_list
  end type spapos_prog_t
  !
contains
  !
  subroutine cubetopology_spapos_register(comm,name,abstract,error)
    !------------------------------------------------------------------------
    !
    !------------------------------------------------------------------------
    class(spapos_comm_t), intent(out)   :: comm
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: abstract
    logical,              intent(inout) :: error
    !
    type(standard_arg_t) :: stdarg
    type(keywordlist_comm_t)  :: keyarg
    character(len=*), parameter :: rname='SPAPOS>REGISTER'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         name,'lpos mpos type [unit]',&
         abstract,&
         "Describe a position in terms of relative or absolute&
         & coordinates. In case of relative coordinates they are&
         & relative to the current projection center, the possible&
         & units for a relative position are FOV units. Absolute&
         & positions can be given in three possible units: Equatorial&
         & (sexagesimal strings in the current spatial frame), Radian&
         & or Degree",&
         comm%key,error)
    if (error) return
    call stdarg%register(&
         'lpos',&
         'Position in L coordinate',&
          '"*" or "=" mean current projection center',&
          code_arg_mandatory,error)
    if (error) return
    call stdarg%register(&
         'mpos',&
         'Position in m coordinate',&
         '"*" or "=" mean current projection center',&
         code_arg_mandatory,&
         error)
    if (error) return
    call keyarg%register(&
         'type',&
         'Coordinates type',&
         strg_id,&
         code_arg_mandatory,&
         ctypes,&
         .not.flexible,&
         comm%coortype,&
         error)
    if (error) return
    call stdarg%register(&
         'unit',&
         'Unit for lpos and mpos',&
         'Available units depend on center type:'//strg_cr//&
         '- FOV units for relative,'//strg_cr//&
         '- equatorial (i.e. sexagesimal hour angles and degrees if &
         &equatorial system, both sexagesimal degrees if galactic system), &
         &degrees or radians for absolute.',&
         code_arg_optional, error)
    if (error) return
  end subroutine cubetopology_spapos_register
  !
  subroutine cubetopology_spapos_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! /POS l m type [unit]
    !----------------------------------------------------------------------
    class(spapos_comm_t), intent(in)    :: comm
    character(len=*),     intent(in)    :: line
    type(spapos_user_t),  intent(out)   :: user
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPAPOS>PARSE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    user%x = strg_star
    user%y = strg_star
    user%type = strg_star
    user%unit = strg_star    
    !
    call comm%key%present(line,user%present,error)
    if (error) return
    if (user%present) then
       call cubetools_getarg(line,comm%key,1,user%x,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%key,2,user%y,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%key,3,user%type,mandatory,error)
       if (error) return
       call cubetools_getarg(line,comm%key,4,user%unit,.not.mandatory,error)
       if (error) return
    endif
  end subroutine cubetopology_spapos_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_spapos_user_init(user,error)
    !----------------------------------------------------------------------
    ! Initialize by setting the intent of user to out
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(out)   :: user 
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='SPAPOS>USER>INIT'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
  end subroutine cubetopology_spapos_user_init
  !
  subroutine cubetopology_spapos_user_from_line(user,line,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! ***JP: SIC parsing code should not be here but in cubetools
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(out)   :: user
    character(len=*),     intent(in)    :: line
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=100) :: reline
    integer(kind=4) :: pos,len,nc
    character(len=*), parameter :: rname='SPAPOS>USER>FROM_LINE'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    pos = 1
    reline=trim(adjustl(line))
    len = len_trim(reline)
    if (len.eq.0) then
       call cubetopology_message(seve%e,rname,'Line is empty')
       error = .true.
       return
    endif
    call sic_next(reline(pos:len),user%x,nc,pos)
    if (pos.ge.len) then
       error = .true.
       mess = 'Only 1 argument, at least 3 expected'
       goto 10
    endif
    call sic_next(reline(pos:len),user%y,nc,pos,dotab=.true.)
    if (pos.ge.len) then
       error = .true.
       mess = 'Only 2 arguments, at least 3 expected'
       goto 10
    endif
    if (pos.lt.len) call sic_next(reline(pos:len),user%type,nc,pos,dotab=.true.)
    if (pos.lt.len) call sic_next(reline(pos:len),user%unit,nc,pos,dotab=.true.)
10  if (error) then
       call cubetopology_message(seve%e,rname,mess)
       call cubetopology_message(seve%e,rname,'Offending line:')
       call cubetopology_message(seve%r,rname,'  '//line)
       return
    endif
    user%present = .true.
  end subroutine cubetopology_spapos_user_from_line
  !
  subroutine cubetopology_spapos_user_toprog(user,cube,prog,error)
    use cubetuple_format
    use cubetools_shape_types
    use cubetools_header_methods
    use cubetools_disambiguate
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user
    class(format_t),      intent(in)    :: cube
    type(spapos_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    type(shape_t) :: n
    integer(kind=4) :: ikey
    character(len=12) :: type
    character(len=*), parameter :: rname='SPAPOS>USER>TOPROG'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    if (user%present) then
       call cubetools_disambiguate_strict(user%type,ctypes,ikey,type,error)
       if (error) return
       select case(type)
       case('ABSOLUTE')
          call user%toprog_abso(cube,prog,error)
          if (error) return
       case(strg_star,'RELATIVE')
          call user%toprog_rela(cube,prog,error)
          if (error) return
       end select      
    else
       prog%rela(:) = 0d0
       call user%toprog_rela(cube,prog,error)
       if (error) return
    endif
    !
    ! Get pixel values
    call cubetools_header_spatial_offset2pixel(cube%head,prog%rela,prog%frac,error)
    if (error) return
    prog%pixe(:) = nint(prog%frac(:))
    call cubetools_header_get_array_shape(cube%head,n,error)
    if (error) return
    prog%ie = prog%pixe(1)+(prog%pixe(2)-1)*n%l
  end subroutine cubetopology_spapos_user_toprog
  !
  subroutine cubetopology_spapos_user_toprog_abso(user,cube,prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetuple_format
    use cubetools_header_interface
    use cubetools_user2prog
    use cubetools_disambiguate
    use cubetools_unit
    use cubetools_spapro_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user
    class(format_t),      intent(in)    :: cube
    type(spapos_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    type(projection_t) :: gproj
    type(unit_user_t) :: posunit
    character(len=unit_l) :: unit
    integer(kind=4) :: ikey
    character(len=*), parameter :: units(4)=&
         [strg_star//'         ','Equatorial','Radian    ','Degree    ']
    character(len=*), parameter :: rname='SPAPOS>USER>TOPROG>ABSO'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call cubetools_disambiguate_strict(user%unit,units,ikey,unit,error)
    if (error) return
    select case(unit)
    case(strg_star,'EQUATORIAL') ! Use sic_decode
       select case(cube%head%spa%fra%code)
       case(code_spaframe_equatorial,code_spaframe_icrs)
          call sic_decode(user%x,prog%abso(1),24,error)
          if (error) return
       case (code_spaframe_galactic)
          call sic_decode(user%x,prog%abso(1),360,error)
          if (error) return
       case default
          call cubetopology_message(seve%e,rname,'Unknown spatial frame code')
          error = .true.
          return
       end select
       call sic_decode(user%y,prog%abso(2),360,error)
       if (error) return
    case('RADIAN','DEGREE')
       ! Unit is Pang because we need either Radian or Degree
       call posunit%get_from_name_for_code(unit,code_unit_pang,error)
       if (error) return
       call cubetools_user2prog_resolve_star(user%x,posunit,cube%head%spa%pro%l0,prog%abso(1),error)
       if (error) return
       call cubetools_user2prog_resolve_star(user%y,posunit,cube%head%spa%pro%m0,prog%abso(2),error)
       if (error) return      
    end select
    !
    ! Convert to relative
    if ((prog%abso(1).eq.cube%head%spa%pro%l0).and.  &
        (prog%abso(2).eq.cube%head%spa%pro%m0)) then
       ! Straightforward, and support any projection including non supported ones, or NONE.
       prog%rela(1) = 0.d0
       prog%rela(2) = 0.d0
    else
       call cubetools_spapro_gwcs(cube%head%spa%pro,gproj,error)
       if (error) return
       call abs_to_rel(gproj,prog%abso(1),prog%abso(2),prog%rela(1),prog%rela(2),1)
    endif
  end subroutine cubetopology_spapos_user_toprog_abso
  !
  subroutine cubetopology_spapos_user_toprog_rela(user,cube,prog,error)
    use gkernel_interfaces
    use gkernel_types
    use cubetuple_format
    use cubetools_spapro_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user
    class(format_t),      intent(in)    :: cube
    type(spapos_prog_t),  intent(out)   :: prog
    logical,              intent(inout) :: error
    !
    integer(kind=4), parameter :: ix = 1
    integer(kind=4), parameter :: iy = 2
    type(projection_t) :: gproj
    character(len=*), parameter :: rname='SPAPOS>USER>TOPROG>RELA'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    call coord_user2prog(cube%head%spa%l,user%unit,user%x,prog%rela(ix),error)
    if (error) return
    call coord_user2prog(cube%head%spa%m,user%unit,user%y,prog%rela(iy),error)
    if (error) return
    !
    ! Convert to absolute
    if ((prog%rela(ix).eq.0.d0).and.(prog%rela(iy).eq.0.d0)) then
       ! Straightforward, and support any projection including non
       ! supported ones, or NONE.
       prog%abso(ix) = cube%head%spa%pro%l0
       prog%abso(iy) = cube%head%spa%pro%m0
    else
       call cubetools_spapro_gwcs(cube%head%spa%pro,gproj,error)
       if (error) return
       call rel_to_abs(gproj,&
            prog%rela(ix),prog%rela(iy),&
            prog%abso(ix),prog%abso(iy),1)
    endif
    !
  contains
    !
    subroutine coord_user2prog(axis,userunit,userval,progval,error)
      use cubetools_unit
      use cubetools_user2prog
      use cubetools_axis_types
      !----------------------------------------------------------------------
      ! If it is covered by the cube, default position is (0,0).
      ! Else center of the covered field of view.
      !----------------------------------------------------------------------
      type(axis_t),      intent(inout) :: axis
      character(len=*),  intent(in)    :: userunit      
      character(len=*),  intent(in)    :: userval
      real(kind=coor_k), intent(out)   :: progval
      logical,           intent(inout) :: error
      !
      real(kind=coor_k) :: default
      type(unit_user_t) :: unit
      !
      ! ***JP: The following is not generic enough. We should take into account
      ! ***JP: the axis unit in case it's not a fov!
      call unit%get_from_name_for_code(userunit,code_unit_fov,error)
      if (error) return
      !
      ! Default in prog unit as per the cubetools_user2prog_resolve_star_r8 API
      if (axis%inside(0.d0)) then
         default = 0d0
      else
         default = (axis%get_min()+axis%get_max())/2.d0
      endif
      !
      call cubetools_user2prog_resolve_star(userval,unit,default,progval,error)
      if (error) return
    end subroutine coord_user2prog
  end subroutine cubetopology_spapos_user_toprog_rela
  !
  subroutine cubetopology_spapos_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging
    !----------------------------------------------------------------------
    class(spapos_user_t), intent(in)    :: user 
    logical,              intent(inout) :: error
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPAPOS>USER>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    write(mess,'(6a,x,a)') &
         'Position  : (',trim(user%x),',',trim(user%y),') ',&
         trim(user%type),trim(user%unit)
    call cubetopology_message(seve%r,rname,mess)
  end subroutine cubetopology_spapos_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubetopology_spapos_prog_list(prog,error)
    use cubetools_unit
    use cubetools_format
    !----------------------------------------------------------------------
    ! User feedback
    !----------------------------------------------------------------------
    class(spapos_prog_t), intent(in)    :: prog 
    logical,              intent(inout) :: error
    !
    type(unit_user_t) :: unit
    real(kind=coor_k) :: offset(2)
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='SPAPOS>PROG>LIST'
    !
    call cubetopology_message(toposeve%trace,rname,'Welcome')
    !
    !***JP: Not generic enough
    call cubetools_format_radec(prog%abso,mess,error)
    if (error) return
    call cubetopology_message(seve%r,rname,mess)
    !
    !***JP: The following is not generic enough. We should take into account
    !***JP: the axis unit in case it's not a fov!
    call unit%get_from_code(code_unit_fov,error)
    if (error) return
    offset = prog%rela*unit%user_per_prog    
    call cubetools_format_offset(offset,unit%name,mess,error)
    if (error) return
    call cubetopology_message(seve%r,rname,mess)
!!$
!!$    print *,'Absolute         ',prog%abso
!!$    print *,'Relative         ',prog%rela
!!$    print *,'Fractional pixel ',prog%frac
!!$    print *,'Integer    pixel ',prog%pixe
!!$    print *,'Entry            ',prog%ie
  end subroutine cubetopology_spapos_prog_list
end module cubetopology_spapos_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubemain_stitch
  use cubetools_structure
  use cubemain_messaging
  use cubemain_merging
  !
  type :: stitch_comm_t
     type(option_t), pointer :: comm
     type(merging_comm_t)    :: merge
   contains
     procedure, public  :: register => cubemain_stitch_register
     procedure, public  :: parse    => cubemain_stitch_parse
     procedure, public  :: main     => cubemain_stitch_main
  end type stitch_comm_t
  type(stitch_comm_t) :: stitch
  !
contains
  !
  subroutine cubemain_stitch_command(line,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(merging_user_t) :: user
    character(len=*), parameter :: rname='STITCH>COMMAND'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call stitch%parse(line,user,error)
    if (error) return
    !
    call stitch%main(user,error)
    if (error) return
  end subroutine cubemain_stitch_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubemain_stitch_register(stitch,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(stitch_comm_t), intent(inout) :: stitch
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='STITCH>REGISTER'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call cubetools_register_command(&
         'STITCH','',&
         'Stitch cubes from the current index',&
         'Stitch the cubes in the current index. The stitching can be&
         & spectrally aligned by usign option /ALIGN. Several aspects&
         & of the output cube can be controlled: its axes&
         & (/LAXIS, /MAXIS, /FAXIS and /VAXIS), its projection&
         & (/PTYPE, /PCENTER and /PANGLE) as well as its&
         & reference frequency and line. A reference cube can be used to&
         & define the spectral and spatial characteristics of&
         & the stitched cube (/LIKE). If no options are given&
         & the axes will be chosen in a way to cover all the&
         & data in all cubes in the index. By default the&
         & family name of the output cube will be the same&
         & of the first cube in the current index, this can&
         & be changed with the usage of option /FAMILY.',&
         cubemain_stitch_command,&
         stitch%comm,&
         error)
    if (error) return
    !
    call stitch%merge%register('stitched',flag_stitch,error)
    if (error) return
  end subroutine cubemain_stitch_register
  !
  subroutine cubemain_stitch_parse(stitch,line,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(stitch_comm_t),  intent(in)    :: stitch
    character(len=*),      intent(in)    :: line
    class(merging_user_t), intent(out)   :: user
    logical,               intent(inout) :: error
    !
    character(len=*), parameter :: rname='STITCH>PARSE'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call stitch%merge%parse(line,user,error)
    if (error) return
  end subroutine cubemain_stitch_parse
  !
  subroutine cubemain_stitch_main(stitch,user,error)
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    class(stitch_comm_t),  intent(in)    :: stitch
    class(merging_user_t), intent(in)    :: user
    logical,               intent(inout) :: error
    !
    type(merging_prog_t) :: prog
    character(len=*), parameter :: rname='STITCH>MAIN'
    !
    call cubemain_message(mainseve%trace,rname,'Welcome')
    !
    call user%toprog(stitch%merge,prog,error)
    if (error) return
    call prog%main(stitch%merge,error)
    if (error) return
  end subroutine cubemain_stitch_main
end module cubemain_stitch
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubedag_dagcomm
  use cubetools_structure
  use cubetools_keywordlist_types
  !
  public :: cubedag_dag_register
  private
  !
  type :: dag_comm_t
     type(option_t),      pointer :: dag
     type(keywordlist_comm_t), pointer :: action_arg
  end type dag_comm_t
  type(dag_comm_t) :: comm
  !
contains
  !
  subroutine cubedag_dag_register(error)
    use cubetools_parameters
    !----------------------------------------------------------------------
    ! 
    !----------------------------------------------------------------------
    logical, intent(out) :: error
    ! Local
    type(keywordlist_comm_t)  :: keyarg
    type(standard_arg_t) :: stdarg
    integer, parameter :: naction = 3
    character(len=*), parameter :: actions(naction) =  &
         (/ 'CLIST  ','PLIST  ','DIGRAPH' /)
    character(len=*), parameter :: rname='DAG>REGISTER'
    !
    call cubetools_register_command(&
         'DAG','action',&
         'For debugging purposes',&
         '* DIGRAPH: produce a .dot file for graphical representation of the DAG'//strg_cr//  &
         '    CUBE> dag digraph 1 toto.dot'//strg_cr//  &
         '    CUBE> system "dot -Tpdf -o toto.pdf toto.dot"'//strg_cr//  &
         '  Modes 2 and 3 result in more verbose nodes.'//strg_cr//  &
         '* CLIST: list the children of a node given its ID'//strg_cr//  &
         '    CUBE> dag clist 3'//strg_cr//  &
         '* PLIST: list the parents of a node given its ID'//strg_cr//  &
         '    CUBE> dag plist 3'//strg_cr,  &
         cubedag_dag_command,&
         comm%dag,error)
    if (error) return
    call keyarg%register( &
         'Action',  &
         'Action to be executed', &
         strg_id,&
         code_arg_mandatory, &
         actions,  &
         .not.flexible,  &
         comm%action_arg,  &
         error)
    if (error) return
    call stdarg%register( &
         'Argument 1',  &
         'First argument to action', &
         strg_id,&
         code_arg_mandatory,error)
    if (error) return
    call stdarg%register( &
         'Argument 2',  &
         'Second argument to action', &
         strg_id,&
         code_arg_optional,error)
    if (error) return
  end subroutine cubedag_dag_register
  !
  subroutine cubedag_dag_command(line,error)
    use cubedag_parameters
    use cubedag_dag
    use cubedag_node_type
    use cubedag_messaging
    use cubedag_digraph
    use cubedag_walker
    !----------------------------------------------------------------------
    ! @ public
    ! DAG DIGRAPH|CLIST|PLIST
    !----------------------------------------------------------------------
    character(len=*), intent(in)  :: line
    logical,          intent(out) :: error
    ! Local
    character(len=*), parameter :: rname='DAG'
    character(len=7) :: chain,key
    integer(kind=4) :: iaction
    character(len=filename_length) :: path
    integer(kind=iden_l) :: id
    class(cubedag_node_object_t), pointer :: object
    type(parentwalker_t) :: parentwalker
    type(childwalker_t) :: childwalker
    !
    call cubetools_getarg(line,comm%dag,1,chain,mandatory,error)
    if (error) return
    call cubetools_keywordlist_user2prog(comm%action_arg,chain,iaction,key,error)
    if (error)  return
    select case (key)
    case ('CLIST')
       call cubetools_getarg(line,comm%dag,2,id,mandatory,error)
       if (error)  return
       call cubedag_dag_get_object(id,object,error)
       if (error)  return
       call childwalker%reset(object,cubedag_walker_null,error)
       if (error)  return
       do while (childwalker%next(object))
          print *,'Found child: ',object%node%id
       enddo
    case ('PLIST')
       call cubetools_getarg(line,comm%dag,2,id,mandatory,error)
       if (error)  return
       call cubedag_dag_get_object(id,object,error)
       if (error)  return
       call parentwalker%reset(object,cubedag_walker_null,error)
       if (error)  return
       do while (parentwalker%next(object))
          print *,'Found parent: ',object%node%id
       enddo
    case ('DIGRAPH')
       call cubetools_getarg(line,comm%dag,2,iaction,mandatory,error)
       if (error)  return
       call cubetools_getarg(line,comm%dag,3,path,mandatory,error)
       if (error)  return
       call cubedag_dag_get_root(object)
       call cubedag_digraph_create(object,.true.,path,iaction,error,inoroot=.false.)
       if (error)  return
    case default
       call cubedag_message(seve%e,rname,'Unknown keyword: '//trim(key))
       error = .true.
       return
    end select
    !
  end subroutine cubedag_dag_command
end module cubedag_dagcomm
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
